#! /bin/perl

 use Net::LDAP;
 use Net::LDAP::Control;

 $ldap = Net::LDAP->new ( "<hostname>", port => 2011 ) or die "$@";
 $userToAuthenticate = "cn=directory manager";
 $passwd = "Secret123";

 $mesg = $ldap->bind ( version => 3 );          # use for searches

 $mesg = $ldap->bind ( "$userToAuthenticate",
                       password => "$passwd",
                       version => 3 );          # use for changes/edits

 sub LDAPsearch
 {
   my ($ldap,$searchString,$attrs,$base) = @_;

   if (!$base ) { $base = "dc=com"; }
   
   # if they don't pass an array of attributes...
   # set up something for them
   
   if (!$attrs ) { $attrs = [ 'cn','mail' ]; }
   
   my $result = $ldap->search ( base    => "$base",
	   scope   => "sub",
	   filter  => "$searchString",
	   attrs   =>  $attrs,
	   control => [ ]
   );
 }

 my $result = LDAPsearch ( $ldap, "uid=*");



my @entries = $result->entries;

 my $entr;
 foreach $entr ( @entries ) {
   print "DN: ", $entr->dn, "\n";

   my $attr;
   foreach $attr ( sort $entr->attributes ) {
     next if ( $attr =~ /;binary$/ );
     print "  $attr : ", $entr->get_value ( $attr ) ,"\n";
     }
     
     print "#-------------------------------\n";
     }
     
